{$S4}
Program Desktop_set;

{A simple program to just rename the DESKTOP.INF file for the proper
 resolution setting.  You *must* create an alternate DESKTOP.INF file
 for 'other' resolution (the one you are not currently in) named either
 DESKTOP.COL (for RGB desktop) or DESKTOP.MON (for the monochrome monitor)
 and place it in the C:\ directory.  Place this program in the AUTO folder
 and it will check the resolution and rename the files if necessary.
 
                                David B. Chiquelin
                                21 May 1989             }

TYPE
  Fname_type = Packed Array[1..80] OF Char;
  
VAR
  x     : Integer;
  l     : Long_Integer;
  iname,cname,
  mname : Fname_type;
  
{ - - - - - }

Function Open_file(VAR f_name : Fname_type ; mode : Integer) : Integer;
  GEMDOS($3D);

{ - - - - - }

Function Close_file(handle : Integer) : Integer;
  GEMDOS($3E);

{ - - - - - }

Function Frename(dummy : Integer; VAR oname, nname : Fname_type):Long_Integer;
  GEMDOS($56);

{ - - - - - }

Function Getrez : Integer;
  XBIOS(4);
  
{ - - - - - }

Procedure Convert_name(txt : String ; VAR fname : Fname_type);

VAR
  x : Integer;

BEGIN
  FOR x:=1 TO 14 DO
    fname[x]:=txt[x];
  fname[15]:=Chr(0)
END;

{ - - - - - }

BEGIN   {Main program}
  Writeln;
  Writeln;
  Convert_name('C:\DESKTOP.INF',iname);
  Convert_name('C:\DESKTOP.COL',cname);
  Convert_name('C:\DESKTOP.MON',mname);
  Writeln('*   DESKTOP.INF file rename utility   *');
  IF Getrez=2 THEN
  BEGIN
    x:=Open_file(mname,0);       {See if there is a .MON file}
    IF x>0 THEN                  {Yes, so must have been on RGB last time}
    BEGIN
      Writeln('* Renaming DESKTOP files - rez change *');
      x:=Close_file(x);
      l:=Frename(0,iname,cname); {Change .INF to .COL}
      l:=Frename(0,mname,iname)  {then .MON to .INF}
    END ELSE Writeln('*        No changes required          *')
  END ELSE                       {Do the same for RGB runs}
  BEGIN
    x:=Open_file(cname,0);
    IF x>0 THEN
    BEGIN
      Writeln('* Renaming DESKTOP files - rez change *');
      x:=Close_file(x);
      l:=Frename(0,iname,mname);
      l:=Frename(0,cname,iname)
    END ELSE Writeln('*        No changes required          *')
  END;
  Writeln
END.
